SystemOrganization addCategory: #AVL!

Object subclass: #AVLNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AVL'!

AVLNode subclass: #AVLCompositeNode
	instanceVariableNames: 'key value left right balance balanceChanged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AVL'!

!AVLCompositeNode class methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 15:10'!
key: aKey value: anObject
   ^super new 
      setKey: aKey 
      value: anObject ! !

!AVLCompositeNode methodsFor: 'private' stamp: 'ShruthiSudhanva 7/5/2013 00:09'!
LLCase
	| leftNode |
	
	leftNode := left veryDeepCopy.
	left := (leftNode right) veryDeepCopy .
	leftNode right: self veryDeepCopy.
	leftNode right updateBalance.
	self become: leftNode.
! !

!AVLCompositeNode methodsFor: 'private' stamp: 'ShruthiSudhanva 7/5/2013 00:54'!
LRCase
	left RRCase.
	self LLCase.! !

!AVLCompositeNode methodsFor: 'private' stamp: 'ShruthiSudhanva 7/5/2013 00:56'!
RLCase
	right LLCase.
	self RRCase.! !

!AVLCompositeNode methodsFor: 'private' stamp: 'ShruthiSudhanva 7/5/2013 00:36'!
RRCase
	| rightNode |
	
	rightNode := right veryDeepCopy.
	right:= (rightNode left) veryDeepCopy .
	rightNode left: self veryDeepCopy.
	rightNode left updateBalance.
	self become: rightNode.
! !

!AVLCompositeNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 15:12'!
at: aKey
   aKey = key ifTrue:[^value].
   aKey < key ifTrue: [^left at: aKey].
   aKey > key ifTrue: [^right at: aKey].! !

!AVLCompositeNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 20:20'!
at: aKey put: anObject 
   | oldValue returnValue |
   aKey < key ifTrue: [
	returnValue := left at: aKey put: anObject.
	self incrementBalance.
	^returnValue.
	].
   aKey > key ifTrue: [
	 returnValue := right at: aKey put: anObject.
	self decrementBalance.
	^returnValue
	].
   oldValue := value.
   value := anObject.
   ^oldValue! !

!AVLCompositeNode methodsFor: 'accessing' stamp: 'ShruthiSudhanva 7/4/2013 19:37'!
balance
	^balance! !

!AVLCompositeNode methodsFor: 'accessing' stamp: 'ShruthiSudhanva 7/4/2013 17:43'!
balanceChanged
	^balanceChanged.! !

!AVLCompositeNode methodsFor: 'accessing' stamp: 'ShruthiSudhanva 7/4/2013 17:48'!
balanceChanged: aBoolean 
	balanceChanged := aBoolean.! !

!AVLCompositeNode methodsFor: 'copying' stamp: 'ShruthiSudhanva 7/5/2013 00:09'!
become: aNode
	key := aNode key.
	value := aNode value.
	left := aNode left.
	right:= aNode right.
	balance := 0.
	balanceChanged := false.! !

!AVLCompositeNode methodsFor: 'private' stamp: 'ShruthiSudhanva 7/4/2013 20:42'!
decrementBalance
	balanceChanged := (left balanceChanged) | (right balanceChanged).
	balanceChanged ifTrue:[ balance := balance - 1 ].
	balance == 0 ifTrue:[ balanceChanged := false].
	left balanceChanged: false.
	right balanceChanged: false.
	balance == -2 ifTrue:[ self rotateLeft ].
! !

!AVLCompositeNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 15:14'!
includes: aKey
   aKey = key ifTrue:[^true].
   aKey < key ifTrue:[^left includes: aKey].
   aKey > key ifTrue:[^right includes: aKey]. ! !

!AVLCompositeNode methodsFor: 'private' stamp: 'ShruthiSudhanva 7/4/2013 21:01'!
incrementBalance
	balanceChanged := (left balanceChanged) | (right balanceChanged).
	balanceChanged ifTrue:[ balance := balance + 1 ].
	balance == 0 ifTrue:[ balanceChanged := false].
	left balanceChanged: false.
	right balanceChanged: false.
	balance == 2 ifTrue:[ self rotateRight].! !

!AVLCompositeNode methodsFor: 'testing' stamp: 'ShruthiSudhanva 7/5/2013 00:10'!
isLeaf
	^false.! !

!AVLCompositeNode methodsFor: 'accessing' stamp: 'ShruthiSudhanva 7/4/2013 21:01'!
key
	^key! !

!AVLCompositeNode methodsFor: 'accessing' stamp: 'ShruthiSudhanva 7/4/2013 23:52'!
left
	^left! !

!AVLCompositeNode methodsFor: 'accessing' stamp: 'ShruthiSudhanva 7/4/2013 23:52'!
left: aNode
	left:= aNode.! !

!AVLCompositeNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 15:14'!
printOn: aStream
   aStream
      nextPutAll: '(';
      print: left;
      print: key;
      print: right;
      nextPutAll: ')' ! !

!AVLCompositeNode methodsFor: 'private' stamp: 'ShruthiSudhanva 7/4/2013 20:21'!
privateAt: aKey put: anObject
   aKey < key ifTrue: [left := AVLCompositeNode key: aKey value: anObject. 
						left balanceChanged: true].
   aKey > key ifTrue: [right :=AVLCompositeNode key: aKey value: anObject. 
						right balanceChanged: true].
   ^anObject.! !

!AVLCompositeNode methodsFor: 'accessing' stamp: 'ShruthiSudhanva 7/4/2013 19:38'!
right
	^right! !

!AVLCompositeNode methodsFor: 'accessing' stamp: 'ShruthiSudhanva 7/4/2013 19:38'!
right: rightNode 
	right := rightNode! !

!AVLCompositeNode methodsFor: 'private' stamp: 'ShruthiSudhanva 7/5/2013 00:41'!
rotateLeft
	right balance == -1 ifTrue: [ self RRCase  ]
	ifFalse: [ self RLCase ]! !

!AVLCompositeNode methodsFor: 'private' stamp: 'ShruthiSudhanva 7/4/2013 21:00'!
rotateRight
	left balance == 1 ifTrue: [ self LLCase  ]
	ifFalse: [ self LRCase ]! !

!AVLCompositeNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 20:09'!
setKey: aKey value: anObject
   key := aKey.
   value := anObject.
   right := AVLLeafNode parent: self.
   left := AVLLeafNode parent: self. 
   balance := 0.
   balanceChanged := false.! !

!AVLCompositeNode methodsFor: 'private' stamp: 'ShruthiSudhanva 7/5/2013 00:08'!
updateBalance
	balance := 0.
	left isLeaf ifFalse: [ balance := balance +1 ].
	right isLeaf ifFalse:[ balance := balance - 1].
	! !

!AVLCompositeNode methodsFor: 'accessing' stamp: 'ShruthiSudhanva 7/4/2013 23:52'!
value
	^value! !

AVLNode subclass: #AVLLeafNode
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AVL'!

!AVLLeafNode class methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 15:14'!
parent: aNode
   ^super new setParent: aNode ! !

!AVLLeafNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 15:15'!
at: aKey
   self keyNotFoundError: aKey
   ! !

!AVLLeafNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 16:24'!
at: aKey put: anObject
   parent privateAt: aKey put: anObject.
   ! !

!AVLLeafNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 15:16'!
includes: aKey
   ^false ! !

!AVLLeafNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/5/2013 00:10'!
isLeaf
	^true! !

!AVLLeafNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 16:18'!
keyNotFoundError: aKey
      ^Dictionary new errorKeyNotFound: aKey ! !

!AVLLeafNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 15:16'!
printOn: aStream ! !

!AVLLeafNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 15:15'!
setParent: aNode
   parent := aNode ! !

!AVLNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 16:26'!
at: aKey! !

!AVLNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 16:25'!
at: aKey put: aValue! !

!AVLNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 17:58'!
balanceChanged
	^false.! !

!AVLNode methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/4/2013 17:58'!
balanceChanged: aBoolean! !

TestCase subclass: #AVLNodeTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AVL'!

!AVLNodeTests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/5/2013 01:01'!
testAt! !

!AVLNodeTests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/5/2013 01:08'!
testAtPut
	| root |
	root := AVLCompositeNode  key: 10 value: 10.
      root 
      at: 5 put: 5;
	at: 12 put: 12;
      at: 3 put: 3;
      at: 6 put: 6;
      at: 1 put: 1;
	at: 15 put:15.
	"
			5
		    /    \
		  3     10
		/       /    \
	    1       6   12
	                     \
	                     15
	"
	self assert: root balance == -1.
	self assert: (root left balance) == 1. 
	self assert: root right left key == 6.! !

!AVLNodeTests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 7/5/2013 01:02'!
testIncludes! !
